<?php

///////////////////////////////////////
// My Links Manager v1.0.0 beta      //
// (C) 2006-2011, Alexander Yanitsky //
// Web site: janicky.com             //
// Email: janickiy@mail.ru           //
// ICQ: 305-972                      //
// MSN: janickiy@live.ru             //
///////////////////////////////////////

// Level of processing of mistakes
Error_Reporting(E_ALL & ~E_NOTICE);

define("DEBUG", 1);

// Require necessary classes
require "../class/class.exception_mysql.php";
require "../class/class.exception_object.php";
require "../class/class.exception_member.php";
require_once '../class/Sigma.php';

// Require necessary libs
require_once "../lib/connect.inc";
require_once "../lib/function.inc";

try
{
   // Get a settings of catalogue
   $query = "SELECT * FROM ".DB_SETTING."";
   $result = $dbh->query($query);

   if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

   $settings = $result->fetch_array();

   // Clear the descriptor
   $result->close();

   if($settings['language'] == 'ru') { $charset = "windows-1251"; }
   else { $charset = "utf-8"; }

   // interface modules, the description of pages and meta tags
   require "templates/language/".$settings['language']."/settings.inc";
   require "templates/language/".$settings['language']."/language.inc";
   require "menu.php";

   // Authenticate
   require "../lib/authenticate.inc";

   $action = "";
   $action = $_POST["action"];

   if(empty($action))
   {
      // template
      $tpl = new HTML_Template_Sigma('.');
      $tpl->loadTemplateFile("templates/settings.html");

      // header
      $tpl->setVariable(array('version'   => $version,
                              'title'     => $title,
                              'titlepage' => $titlepage,
                              'charset'   => $charset,
                              'VERSION'   => VERSION));

      // menu
      $tpl->setVariable(array('INDEXTITLE'    => INDEXTITLE,
                              'ADDLINKTITLE'  => ADDLINKTITLE,
                              'CATTITLE'      => CATTITLE,
                              'CHECKTITLE'    => CHECKTITLE,
                              'EDITTITLE'     => EDITTITLE,
                              'SETTINGSTITLE' => SETTINGSTITLE,
                              'BLACKTITLE'    => BLACKTITLE,
                              'BACKUPTITLE'   => BACKUPTITLE,
                              'DESIGNTITLE'   => DESIGNTITLE,
                              'MENUINDEX'     => MENUINDEX,
                              'MENUADDURL'    => MENUADDURL,
                              'MENUCAT'       => MENUCAT,
                              'MENUCHECK'     => MENUCHECK,
                              'MENUEDIT'      => MENUEDIT,
                              'MENUSETTING'   => MENUSETTING,
                              'MENUBLACK'     => MENUBLACK,
                              'MENUCHANGE'    => MENUCHANGE,
                              'MENUBACKUP'    => MENUBACKUP,
                              'MENUDESIGN'    => MENUDESIGN));

      $tpl->setVariable(array('choosenav1' => $choosenav1,
                              'choosenav2' => $choosenav2,
                              'choosenav3' => $choosenav3,
                              'choosenav4' => $choosenav4,
                              'choosenav5' => $choosenav5,
                              'choosenav6' => $choosenav6,
                              'choosenav7' => $choosenav7,
                              'choosenav8' => $choosenav8,
                              'choosenav9' => $choosenav9,
                              'choosenav10' => $choosenav10));

      if(empty($settings['my_url']))
      {
         if(substr($_SERVER['SERVER_NAME'],0,4) == "www.") { $settings['my_url'] = substr($_SERVER["SERVER_NAME"],4); }
         else { $settings['my_url'] = $_SERVER['SERVER_NAME']; }
      }

      if($settings['language'] == "ru") { $language_ru = 'selected'; }
      else { $language_ru = ''; }

      if($settings['language'] == "en") { $language_en = 'selected'; }
      else { $language_en = ''; }

      if($settings['view_order'] == 1) { $view_order1 = 'checked'; }
      else { $view_order1 = ''; }

      if(($settings['view_order'] == 2) or empty($settings['view_order'])) { $view_order2 = 'checked'; }
      else { $view_order2 = ''; }

      if($settings['order_link'] == 1) { $order_link1 = 'checked'; }
      else { $order_link1 = '';  }

      if(($settings['order_link'] == 2) or empty($settings['order_link'])) { $order_link2 = 'checked'; }
      else { $order_link2 = ''; }

      if($settings['show_cy'] == "yes") { $show_cy = 'checked'; }
      else { $show_cy = '';  }

      if($settings['show_pr'] == "yes")  { $show_pr = 'checked'; }
      else { $show_pr = ''; }

      if($settings['static'] == 1) { $static1 = 'checked'; }
      else { $static1 = ''; }

      if(($settings['static'] == 2) or empty($settings['static'])) { $static2 = 'checked'; }
      else { $static2 = ''; }

      if($settings['show_sec_code'] == "yes") { $show_sec_code = 'checked'; }
      else { $show_sec_code = ''; }

      if($settings['add_link'] == "yes") { $add_link = 'checked'; }
      else { $add_link = ''; }

      if($settings['search'] == "yes") { $search = 'checked'; }
      else { $search = ''; }

      if($settings['others'] == "yes") { $others = 'checked';  }
      else {  $others = 'checked'; }

      if($settings['many_link'] == "yes") { $many_link = 'checked'; }
      else { $many_link = '';  }

      if($settings['common_host'] == "yes") { $common_host = 'checked'; }
      else { $common_host = ''; }

      if($settings['query_check'] == "yes") { $query_check = 'checked';  }
      else { $query_check = ''; }

      if($settings['no_add_link'] == "yes") { $no_add_link = 'checked'; }
      else { $no_add_link = ''; }

      if($settings['black'] == "yes") { $black = 'checked'; }
      else { $black = ''; }

      if($settings['send_mail'] == "yes") { $send_mail = 'checked'; }
      else { $send_mail = ''; }

      // print form
      $tpl->setVariable(array('STR_DEFAULT_VALUE_EMAIL' => $STR_DEFAULT_VALUE_EMAIL,
                              'STR_DEFAULT_VALUE_RULES' => $STR_DEFAULT_VALUE_RULES,
                              'STR_DEFAULT_VALUE_CODE_SITE1'   => $STR_DEFAULT_VALUE_CODE_SITE1,
                              'STR_DEFAULT_VALUE_SEND_MAIL1'   => $STR_DEFAULT_VALUE_SEND_MAIL1,
                              'STR_DEFAULT_VALUE_SEND_MAIL2'   => $STR_DEFAULT_VALUE_SEND_MAIL2,
                              'STR_DEFAULT_VALUE_SEND_MAIL3'   => $STR_DEFAULT_VALUE_SEND_MAIL3,
                              'STR_DEFAULT_VALUE_SEND_MAIL4'   => $STR_DEFAULT_VALUE_SEND_MAIL4,
                              'STR_DEFAULT_VALUE_SEND_MAIL5'   => $STR_DEFAULT_VALUE_SEND_MAIL5,
                              'STR_DEFAULT_VALUE_SEND_MAIL6'   => $STR_DEFAULT_VALUE_SEND_MAIL6,
                              'STR_DEFAULT_VALUE_SEND_MAIL7'   => $STR_DEFAULT_VALUE_SEND_MAIL7,
                              'STR_DEFAULT_VALUE_FROM_ADD_MSG' => $STR_DEFAULT_VALUE_FROM_ADD_MSG));

      if($charset == 'utf-8') $LANG_RU = iconv('windows-1251','utf-8',LANG_RU);
      else $LANG_RU = LANG_RU;

      $tpl->setVariable(array('VIEW'     => VIEW,
                              'LANGUAGE' => LANGUAGE,
                              'LANG_RU'  => $LANG_RU,
                              'LANG_EN'  => LANG_EN,
                              'NUMBER_OF_LINKS_ON_ONE_PAGE' => NUMBER_OF_LINKS_ON_ONE_PAGE,
                              'NUMBER_OF_NEW_LINKS' => NUMBER_OF_NEW_LINKS,
                              'NUMBER_OF_COLUMNS'   => NUMBER_OF_COLUMNS,
                              'HOW_TO_SORT_LINKS'   => HOW_TO_SORT_LINKS,
                              'BY_DATE'     => BY_DATE,
                              'BY_NUMBER'   => BY_NUMBER,
                              'ORDER_OF_SORTING_LINK' => ORDER_OF_SORTING_LINK,
                              'BY_INCREACE' => BY_INCREACE,
                              'BY_DECREASE' => BY_DECREASE,
                              'SHOW_CY' => SHOW_CY,
                              'SHOW_PR' => SHOW_PR,
                              'HINT_VIEW_OF_URL_ADDRESS' => HINT_VIEW_OF_URL_ADDRESS,
                              'VIEW_OF_URL_ADDRESS' => VIEW_OF_URL_ADDRESS,
                              'STATIC_URL'  => STATIC_URL,
                              'DYNAMIC_URL' => DYNAMIC_URL,
                              'URL_ADDRESS_CATALOG' => URL_ADDRESS_CATALOG,
                              'ADMIN_EMAIL'  => ADMIN_EMAIL,
                              'CATALOG_RULE' => CATALOG_RULE,
                              'MSG_FOR_USER_AFTER_ADDITION' => MSG_FOR_USER_AFTER_ADDITION,
                              'HTML_CODE1' => HTML_CODE1,
                              'HTML_CODE2' => HTML_CODE2,
                              'HTML_CODE3' => HTML_CODE3,
                              'HTML_BANNER1' => HTML_BANNER1,
                              'HTML_BANNER2' => HTML_BANNER2,
                              'HTML_BANNER3' => HTML_BANNER3,
                              'LETTERS_TEMPLATES' => LETTERS_TEMPLATES,
                              'EMAIL_FOR_USER_ADD_MODER'    => EMAIL_FOR_USER_ADD_MODER,
                              'EMAIL_FOR_USER_ADD_CATALOG'  => EMAIL_FOR_USER_ADD_CATALOG,
                              'EMAIL_FOR_USER_HIDE_ABSENSE' => EMAIL_FOR_USER_HIDE_ABSENSE,
                              'EMAIL_FOR_USER_HIDE_PROHIB'  => EMAIL_FOR_USER_HIDE_PROHIB,
                              'EMAIL_FOR_USER_PASSED'  => EMAIL_FOR_USER_PASSED,
                              'EMAIL_FOR_USER_REMOVE'  => EMAIL_FOR_USER_REMOVE,
                              'EMAIL_FOR_USER_ADD_NEW' => EMAIL_FOR_USER_ADD_NEW,
                              'GENERAL'                => GENERAL,
                              'MINIMAL_INTV_VERIF_LINK' => MINIMAL_INTV_VERIF_LINK,
                              'NUMBER_OF_VERIFICATION_LINK'  => NUMBER_OF_VERIFICATION_LINK,
                              'NUMBER_OF_CHARACTER_IN_BRIEF' => NUMBER_OF_CHARACTER_IN_BRIEF,
                              'NUMBER_OF_CHAR_IN_FULL_DESC'  => NUMBER_OF_CHAR_IN_FULL_DESC,
                              'NUMBER_OF_CHAR_IN_HTML_CODE'  => NUMBER_OF_CHAR_IN_HTML_CODE,
                              'HINT_REQUEST_CAPTCHA'    => HINT_REQUEST_CAPTCHA,
                              'REQUEST_CAPTCHA'         => REQUEST_CAPTCHA,
                              'HINT_ALLOW_ADD_PASSING_CHECK' => HINT_ALLOW_ADD_PASSING_CHECK,
                              'ALLOW_ADD_PASSING_CHECK' => ALLOW_ADD_PASSING_CHECK,
                              'HINT_CHECK_RECIP_LINK'   => HINT_CHECK_RECIP_LINK,
                              'CHECK_RECIP_LINK'            => CHECK_RECIP_LINK,
                              'HINT_FORBID_SPECIFY_DIFFURL' => HINT_FORBID_SPECIFY_DIFFURL,
                              'FORBID_SPECIFY_DIFFURL'      => FORBID_SPECIFY_DIFFURL,
                              'HINT_FORBID_ADD_MULTIURL_HTML_CODE' => HINT_FORBID_ADD_MULTIURL_HTML_CODE,
                              'FORBID_ADD_MULTIURL_HTML_CODE' => FORBID_ADD_MULTIURL_HTML_CODE,
                              'FORBID_ADD_LINKS_SAME_HOSTING' => FORBID_ADD_LINKS_SAME_HOSTING,
                              'FORBID_SPECIFY_IN_ARG' => FORBID_SPECIFY_IN_ARG,
                              'FORBID_ADD_LINKS_MORE' => FORBID_ADD_LINKS_MORE,
                              'HINT_ADD_LINK_TO_BLACKLIST' => HINT_ADD_LINK_TO_BLACKLIST,
                              'ADD_LINK_TO_BLACKLIST' => ADD_LINK_TO_BLACKLIST,
                              'HINT_VERIFY_ADMIN'     => HINT_VERIFY_ADMIN,
                              'VERIFY_ADMIN'          => VERIFY_ADMIN,
                              'SAVE_CHANGES'          => SAVE_CHANGES,
                              'BY_DEFAULT'            => BY_DEFAULT));

      $tpl->setVariable(array('server_name'                    => $_SERVER['SERVER_NAME'],
                              'language_ru'                    => $language_ru,
                              'language_en'                    => $language_en,
                              'all_number_link'                => $settings['all_number_link'],
                              'all_number_new'                 => $settings['all_number_new'],
                              'stl'                            => $settings['stl'],
                              'view_order1'                    => $view_order1,
                              'view_order2'                    => $view_order2,
                              'order_link1'                    => $order_link1,
                              'order_link2'                    => $order_link2,
                              'show_cy'                        => $show_cy,
                              'show_pr'                        => $show_pr,
                              'static1'                        => $static1,
                              'static2'                        => $static2,
                              'my_url'                         => $settings['my_url'],
                              'admin_email'                    => $settings['admin_email'],
                              'rules'                          => $settings['rules'],
                              'from_add_message'               => $settings['from_add_message'],
                              'code_site1'                     => $settings['code_site1'],
                              'code_site2'                     => $settings['code_site2'],
                              'code_site3'                     => $settings['code_site3'],
                              'code_banner1'                   => $settings['code_banner1'],
                              'code_banner2'                   => $settings['code_banner2'],
                              'code_banner3'                   => $settings['code_banner3'],
                              'send_mail_1'                    => $settings['send_mail_1'],
                              'send_mail_2'                    => $settings['send_mail_2'],
                              'send_mail_3'                    => $settings['send_mail_3'],
                              'send_mail_4'                    => $settings['send_mail_4'],
                              'send_mail_6'                    => $settings['send_mail_6'],
                              'send_mail_7'                    => $settings['send_mail_7'],
                              'send_mail_5'                    => $settings['send_mail_5'],
                              'day'                            => $settings['day'],
                              'Number_Check'                   => $settings['Number_Check'],
                              'count_description_link_min'     => $settings['count_description_link_min'],
                              'count_description_link_max'     => $settings['count_description_link_max'],
                              'count_fulldescription_link_min' => $settings['count_fulldescription_link_min'],
                              'count_fulldescription_link_max' => $settings['count_fulldescription_link_max'],
                              'count_html'                     => $settings['count_html'],
                              'show_sec_code'                  => $show_sec_code,
                              'add_link'                       => $add_link,
                              'search'                         => $search,
                              'others'                         => $others,
                              'many_link'                      => $many_link,
                              'common_host'                    => $common_host,
                              'query_check'                    => $query_check,
                              'no_link'                        => $settings['no_link'],
                              'no_add_link'                    => $no_add_link,
                              'black'                          => $black,
                              'send_mail'                      => $send_mail));

      // Count a quantity of the links
      $query = "SELECT COUNT(*) FROM ".DB_LINK." WHERE hide = 'show'";
      $result = $dbh->query($query);
      $total = $result->fetch_assoc();

      // Clear the descriptor
      $result->close();

      if($charset == 'utf-8') $LOGO = iconv('windows-1251','utf-8',LOGO);
      else $LOGO = LOGO;

      // footer
      $tpl->setVariable(array('total_links' => $total['COUNT(*)'],
                              'help'        => $help,
                              'AUTHOR'      => AUTHOR,
                              'LOGO'        => $LOGO,
                              'WEBSITE'     => WEBSITE,
                              'HELPPAGE'    => HELPPAGE,
                              'FAQPAGE'     => FAQPAGE,
                              'LINKS_IN_CATALOG' => LINKS_IN_CATALOG));
      //
      $tpl->show();
   }

   if(!empty($action))
   {
      $_POST['all_number_link'] = trim($_POST['all_number_link']);
      $_POST['all_number_new'] = trim($_POST['all_number_new']);
      $_POST['name_cont_link'] = trim($_POST['name_cont_link']);
      $_POST['stl'] = trim($_POST['stl']);
      $_POST['count_description_link_min'] = trim($_POST['count_description_link_min']);
      $_POST['count_description_link_max'] = trim($_POST['count_description_link_max']);
      $_POST['count_fulldescription_link_min'] = trim($_POST['count_fulldescription_link_min']);
      $_POST['count_fulldescription_link_max'] = trim($_POST['count_fulldescription_link_max']);
      $_POST['count_html'] = trim($_POST['count_html']);
      $_POST['view_order'] = $_POST['view_order'];
      $_POST['order_link'] = $_POST['order_link'];
      $_POST['my_url'] = trim(strtolower($_POST['my_url']));

      if(substr($_POST['my_url'], 0, 7) == "http://") { $my_url = str_replace('http://','',$_POST['my_url']); }
      if(substr($_POST['my_url'], 0, 4) == "www.") { $_POST['my_url'] = str_replace('www.','',$_POST['my_url']); }
      if(strpos($_POST['my_url'],'/')>0) list($_POST['my_url']) = explode('/',$_POST['my_url']);

      $_POST['admin_email'] = $_POST['admin_email'];
      $_POST['rules'] = $_POST['rules'];
      $_POST['code_site1'] = trim($_POST['code_site1']);
      $_POST['code_site2'] = trim($_POST['code_site2']);
      $_POST['code_site3'] = trim($_POST['code_site3']);
      $_POST['code_banner1'] = trim($_POST['code_banner1']);
      $_POST['code_banner2'] = trim($_POST['code_banner2']);
      $_POST['code_banner3'] = trim($_POST['code_banner3']);
      $_POST['day'] = trim($_POST['day']);
      $_POST['Number_Check'] = trim($_POST['Number_Check']);

      // Shield the special characters
      if(!get_magic_quotes_gpc())
      {
         $_POST['language'] = mysql_escape_string($_POST['language']);
         $_POST['all_number_link'] = mysql_escape_string($_POST['all_number_link']);
         $_POST['all_number_new'] = mysql_escape_string($_POST['all_number_new']);
         $_POST['stl'] = mysql_escape_string($_POST['stl']);
         $_POST['count_description_link_min'] = mysql_escape_string($_POST['count_description_link_min']);
         $_POST['count_description_link_max'] = mysql_escape_string($_POST['count_description_link_max']);
         $_POST['count_fulldescription_link_min'] = mysql_escape_string($_POST['count_fulldescription_link_min']);
         $_POST['count_fulldescription_link_max'] = mysql_escape_string($_POST['count_fulldescription_link_max']);
         $_POST['count_html'] = mysql_escape_string($_POST['count_html']);
         $_POST['admin_email'] = mysql_escape_string($_POST['admin_email']);
         $_POST['my_url'] = mysql_escape_string($_POST['my_url']);
         $_POST['rules'] = mysql_escape_string($_POST['rules']);
         $_POST['code_site1'] = mysql_escape_string($_POST['code_site1']);
         $_POST['code_site2'] = mysql_escape_string($_POST['code_site2']);
         $_POST['code_site3'] = mysql_escape_string($_POST['code_site3']);
         $_POST['code_banner1'] = mysql_escape_string($_POST['code_banner1']);
         $_POST['code_banner2'] = mysql_escape_string($_POST['code_banner2']);
         $_POST['code_banner3'] = mysql_escape_string($_POST['code_banner3']);
         $_POST['send_mail_1'] = mysql_escape_string($_POST['send_mail_1']);
         $_POST['send_mail_2'] = mysql_escape_string($_POST['send_mail_2']);
         $_POST['send_mail_3'] = mysql_escape_string($_POST['send_mail_3']);
         $_POST['send_mail_4'] = mysql_escape_string($_POST['send_mail_4']);
         $_POST['send_mail_5'] = mysql_escape_string($_POST['send_mail_5']);
         $_POST['send_mail_6'] = mysql_escape_string($_POST['send_mail_6']);
         $_POST['send_mail_7'] = mysql_escape_string($_POST['send_mail_7']);
         $_POST['from_add_message'] = mysql_escape_string($_POST['from_add_message']);
         $_POST['no_link'] = mysql_escape_string($_POST['no_link']);
         $_POST['day'] = mysql_escape_string($_POST['day']);
         $_POST['Number_Check'] = mysql_escape_string($_POST['Number_Check']);
      }

      if($_POST['add_link'] == "on") { $_POST['add_link'] = "yes"; }
      else { $_POST['add_link'] = "no"; }
      if($_POST['send_mail'] == "on") { $_POST['send_mail'] = "yes"; }
      else { $_POST['send_mail'] = "no"; }
      if($_POST['search'] == "on") { $_POST['search'] = "yes"; }
      else { $_POST['search'] = "no"; }
      if(($_POST['no_add_link'] == "on")&&($_POST['no_link'] != "0")) { $_POST['no_add_link'] = "yes"; }
      else { $_POST['no_add_link'] = "no"; }
      if($_POST['many_link'] == "on") { $_POST['many_link'] = "yes"; }
      else { $_POST['many_link'] = "no"; }
      if($_POST['others'] == "on") { $_POST['others'] = "yes"; }
      else { $_POST['others'] = "no"; }
      if($_POST['black'] == "on") { $_POST['black'] = "yes"; }
      else { $_POST['black'] = "no"; }
      if($_POST['show_sec_code'] == "on") { $_POST['show_sec_code'] = "yes"; }
      else { $_POST['show_sec_code'] = "no"; }
      if($_POST['show_pr'] == "on") { $_POST['show_pr'] = "yes"; }
      else { $_POST['show_pr'] = "no"; }
      if($_POST['show_cy'] == "on") { $_POST['show_cy'] = "yes"; }
      else { $_POST['show_cy'] = "no"; }
      if($_POST['common_host'] == "on") { $_POST['common_host'] = "yes"; }
      else { $_POST['common_host'] = "no"; }
      if($_POST['query_check'] == "on") { $_POST['query_check'] = "yes"; }
      else { $_POST['query_check'] = "no"; }

      // Add changes to DB
      $update = "UPDATE ".DB_SETTING." SET language = '".$_POST['language']."',
                                           all_number_link = '".$_POST['all_number_link']."',
                                           all_number_new = '".$_POST['all_number_new']."',
                                           stl = '".$_POST['stl']."',
                                           count_description_link_min = '".$_POST['count_description_link_min']."',
                                           count_description_link_max = '".$_POST['count_description_link_max']."',
                                           count_fulldescription_link_min = '".$_POST['count_fulldescription_link_min']."',
                                           count_fulldescription_link_max = '".$_POST['count_fulldescription_link_max']."',
                                           count_html = '".$_POST['count_html']."',
                                           view_order = '".$_POST['view_order']."',
                                           order_link = '".$_POST['order_link']."',
                                           my_url = '".$_POST['my_url']."',
                                           admin_email = '".$_POST['admin_email']."',
                                           rules = '".$_POST['rules']."',
                                           code_site1 = '".$_POST['code_site1']."',
                                           code_site2 = '".$_POST['code_site2']."',
                                           code_site3 = '".$_POST['code_site3']."',
                                           code_banner1 = '".$_POST['code_banner1']."',
                                           code_banner2 = '".$_POST['code_banner2']."',
                                           code_banner3 = '".$_POST['code_banner3']."',
                                           send_mail = '".$_POST['send_mail']."',
                                           add_link = '".$_POST['add_link']."',
                                           search = '".$_POST['search']."',
                                           send_mail_1 = '".$_POST['send_mail_1']."',
                                           send_mail_2 = '".$_POST['send_mail_2']."',
                                           send_mail_3 = '".$_POST['send_mail_3']."',
                                           send_mail_4 = '".$_POST['send_mail_4']."',
                                           send_mail_5 = '".$_POST['send_mail_5']."',
                                           send_mail_6 = '".$_POST['send_mail_6']."',
                                           send_mail_7 = '".$_POST['send_mail_7']."',
                                           from_add_message = '".$_POST['from_add_message']."',
                                           no_add_link = '".$_POST['no_add_link']."',
                                           no_link = '".$_POST['no_link']."',
                                           many_link = '".$_POST['many_link']."',
                                           common_host = '".$_POST['common_host']."',
                                           others = '".$_POST['others']."',
                                           black = '".$_POST['black']."',
                                           day = '".$_POST['day']."',
                                           Number_Check = '".$_POST['Number_Check']."',
                                           static = '".$_POST['static']."',
                                           show_sec_code = '".$_POST['show_sec_code']."',
                                           show_cy = '".$_POST['show_cy']."',
                                           show_pr = '".$_POST['show_pr']."',
                                           query_check = '".$_POST['query_check']."'";

      if($dbh->query($update))
      {
         if($_POST['static'] == 1)
         {
            // Write data in .htaccess
            $root = strpos($_SERVER['REQUEST_URI'], "admin");
            $dir = substr($_SERVER['REQUEST_URI'], 0, $root);
            $content = "RewriteEngine on\r\nRewriteBase "."$dir"."\r\nRewriteCond %{REQUEST_URI} \.html$\r\nRewriteRule ^page_([^/]+)_([^/\.]+)\.html$ index.php?id_cat=$1&page=$2 [L]\r\nRewriteCond %{REQUEST_URI} \.html$\r\nRewriteRule ^link_([^/]+)_([^/\.]+)\.html$ index.php?id_link=$1&page=$2 [L]\r\nRewriteCond %{REQUEST_URI} \.html$\r\nRewriteRule ^link_([^/]+)\.html$ index.php?id_link=$1 [L]\r\nRewriteCond %{REQUEST_URI} \.html$\r\nRewriteRule ^index\.html$ index.php [L]\r\n";
            $hfile = fopen("../.htaccess","w");

            fputs($hfile, "$content");
            fclose($hfile);
         }

         if($_POST['static'] == 2)
         {
            // Clear the content of .htaccess
            $hfile = fopen("../.htaccess","w");

            fputs($hfile, "");
            fclose($hfile);
         }

         // Return to back if a query was executed successfully
         back($MSG_SUCCESSFLLY_CHANGE,'settings.php',2);
      }
      else { throw new ExceptionMySQL($dbh->error,$update,"Error executing SQL query!"); }
   }

   // Close a DB connection
   $dbh->close();
}
catch(ExceptionObject $exc)
{
   require_once("../lib/exception_object_debug.inc");
}
catch(ExceptionMySQL $exc)
{
   require_once("../lib/exception_mysql_debug.inc");
}
catch(ExceptionMember $exc)
{
   require_once("../lib/exception_member_debug.inc");
}

?>